
/******************************************************************************

Coral Tree nl/mptest.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <nl/nl.h>

#define BUFFERSIZE 1000

int main(int argc, char *argv[])
{
	if(argc > 1)
	{
		NL_Channel	channel;

		if(argc != 3)
		{
			fprintf(stderr,"USAGE: %s <server> <text>\n",argv[0]);
			exit(-1);
		}

		channel.Set(NL_INET,NL_IP,NL_CONNECTED,0,argv[1],6100);
		channel.Open();
		channel.Connect();

		while(1)
		{
			fprintf(stderr,"Sending [%s].....",argv[2]);
			channel.Send(argv[2],strlen(argv[2]));
			fprintf(stderr,"Sent\n");
			sleep(1);
		}
	}
	else
	{
		NL_Multiplexor		mplexor;
		NL_Channel			listen_channel;
		NL_Channel			*new_channel;
		NL_ChannelNode		*channel_node;
		NL_ChannelNode		*new_channel_node;
		GPL_DoubleList<NL_ChannelNode>	*checklist;
		GPL_DoubleList<NL_ChannelNode>	*readylist;
		int items;
		char buffer[BUFFERSIZE+1];

		listen_channel.Set(NL_INET,NL_IP,NL_CONNECTED,6100);
		listen_channel.Open();
		listen_channel.SpecifyQueue();

		checklist = mplexor.GetChecklist();
		readylist = mplexor.GetReadylist();

		channel_node = new NL_ChannelNode(&listen_channel,NL_READ);
		checklist->AppendNode(channel_node);

		mplexor.SetTimeout(5000);

		while(1)
		{
			if(mplexor.Wait())
			{
				readylist->ToHead();
				while((channel_node = readylist->PostIncrement())!=NULL)
				{
					if(channel_node->flags != NL_READ)
					{
						fprintf(stderr,"flags failure\n");
						exit(-1);
					}
					if(channel_node->channel == &listen_channel)
					{
						/* MAKE NEW CONNECTION */
						fprintf(stderr,"Making new connection.....");
						new_channel = listen_channel.Accept();
						if(!new_channel)
						{
							fprintf(stderr,"could not accept\n");
							exit(-1);
						}
						new_channel_node = new NL_ChannelNode(new_channel,NL_READ);
						checklist->AppendNode(new_channel_node);
						fprintf(stderr,"Made\n");
					}
					else
					{
						/* READ INCOMING TEXT */
						while( (items=(int)channel_node->channel->Receive(buffer,BUFFERSIZE)) == NL_CHANNEL_WOULD_BLOCK )
						{
							/* NOOP */
						}
						if(!items)
						{
							fprintf(stderr,"SOCKET %d APPEARS TO HAVE DIED\n",channel_node->channel->GetIPHandle());
							checklist->ToHead();
							while((new_channel_node = checklist->PostIncrement())!=NULL)
							{
								if(new_channel_node->channel == channel_node->channel)
								{
									checklist->RemoveNode(new_channel_node);
									delete new_channel_node->channel;
									delete new_channel_node;
									break;
								}
							}
						}
						else
						{
							buffer[items]=0;
							fprintf(stderr,"RECEIVED [%s] FROM %d\n",buffer,channel_node->channel->GetIPHandle());
						}
					}
				}
			}
			else
			{
				fprintf(stderr,"MULTIPLEXOR TIMED OUT\n");
			}
		}
	}
	
	//return 0;
}
	
