
/******************************************************************************

Coral Tree nl/nltest.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/


#include "nl.h"


#define BUFFERSIZE	1000


/******************************************************************************
int		main(int argc,char **argv,char **envp)

	server and client to test out the NL_Channel object

	use any arg to run as client, otherwise runs as server

Keywords: NL_Channel, network
******************************************************************************/
/*PROTOTYPE*/
int main(int argc,char **argv,char **envp)
	{
	NL_Channel channel;

	char buffer[BUFFERSIZE];
	char myname[100];

	long n,items;
	long block;
	long tcp;

	short am_client=FALSE;


	if(argc>2)
		{
		printf("Syntax: %s [server]\n  Specification of server name activates client mode\n",argv[0]);
		return TRUE;
		}

	if(argc>1)
		{
		strcpy(myname,"Client");
		am_client=TRUE;
		}
	else
		strcpy(myname,"Server");

	printf("Running %s\n",myname);

	channel.AddDomain(NL_INET);
	channel.AddProtocol(NL_IP);

//	for(block=0;block<2;block++)
	for(block=1;block>=0;block--)
		{
		printf("%s: BLOCKING %s\n",myname,block? "ON": "OFF");

		channel.SetBlocking((short) block);

//		for(tcp=0;tcp<2;tcp++)
		for(tcp=1;tcp>=0;tcp--)
			{
			printf("%s: %s\n",myname,tcp? "TCP": "UDP");

			if(tcp)
				channel.SetConnectionType(NL_CONNECTED);
			else
				channel.SetConnectionType(NL_CONNECTIONLESS);

			if(am_client)
				{
				channel.SetAddress(NL_REMOTE,argv[1]);
				channel.SetPort(NL_LOCAL, (uint16)(6010+tcp));
if(tcp) sleep(2);

				if(tcp)
					channel.SetPort(NL_REMOTE,"nl-tcptest");
				else
					channel.SetPort(NL_REMOTE,"nl-udptest");

				while( !channel.Open() )
					{
					printf("%s: trying to open/bind\n",myname);
					sleep(1);
					}

				if(tcp)
				{
					/* BLOCK TO INTERSECT WITH NON BLOCKING ACCEPT */
					channel.SetBlocking(TRUE);
					if(!channel.Connect())
					{
						NL_PRINT(NL_APP,NL_ERROR,"could not connect");
					}
					channel.SetBlocking((short) block);
				}

				sprintf(buffer,"hello world");

				items=strlen(buffer);
				printf("%s: sending %d bytes: \"%s\"\n",myname,items,buffer);

				items=channel.Send(buffer,items);
				printf("%s: sent %d bytes of \"%s\"\n",myname,items,buffer);

				while( (items=channel.Receive(buffer,BUFFERSIZE)) == NL_CHANNEL_WOULD_BLOCK )
					{
					printf("%s: waiting for data (non-blocking)\n",myname);
					sleep(1);
					}

				buffer[items]=0;

				printf("%s: received %d bytes: \"%s\"\n",myname,items,buffer);
				printf("  From %u port %d\n",channel.GetAddress(NL_RETURN),channel.GetPort(NL_RETURN));

				channel.Close();
				/* make sure server gets a chance to restart */
				sleep(1);
				}
			else
				{
				NL_Channel *newchannel;

				if(tcp)
					channel.SetPort(NL_LOCAL,"nl-tcptest");
				else
					channel.SetPort(NL_LOCAL,"nl-udptest");

				while( !channel.Open() )
					{
					printf("%s: trying to open/bind\n",myname);
					sleep(1);
					}

				if(tcp)
					while( (newchannel=channel.Accept()) == NULL )
						{
						printf("%s: waiting for connection (non-blocking)\n",myname);
						sleep(1);
						}
				else
					newchannel=&channel;

				while( (items=newchannel->Receive(buffer,BUFFERSIZE)) == NL_CHANNEL_WOULD_BLOCK )
					{
					printf("%s: waiting for data (non-blocking)\n",myname);
					sleep(1);
					}

				buffer[items]=0;
				
				printf("%s: received %d bytes: \"%s\"\n",myname,items,buffer);
				printf("  From %u port %d\n",newchannel->GetAddress(NL_RETURN),newchannel->GetPort(NL_RETURN));

				/* capitalize (crude) */
				for(n=0;n<items;n++)
					if(buffer[n]>='a' && buffer[n]<='z')
						buffer[n]+= 'A'-'a';

				if(!tcp)
					{
					newchannel->SetAddress(NL_REMOTE,newchannel->GetAddress(NL_RETURN));
					newchannel->SetPort(NL_REMOTE,newchannel->GetPort(NL_RETURN));
					}

				printf("%s: sending %d bytes: \"%s\"\n",myname,items,buffer);

				items=newchannel->Send(buffer,items);
				printf("%s: sent %d bytes of \"%s\"\n",myname,items,buffer);
				newchannel->Close();
				channel.Close();
				}


			printf("\n");
			}
		}

return 0;
}
