#ifndef DNA_ISERVER_H
#define DNA_ISERVER_H

/******************************************************************************

Coral Tree dna/iserver.h
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <gpl/gpl.h>

#include <dna/connect.h>
#include <dna/ipmplex.h>

/******************************************************************************
class DNA_IterativeServer

Network connection server.
******************************************************************************/
class DNA_IterativeServer : public DNA_Server
{
	public:
		DNA_IterativeServer(void);
		virtual ~DNA_IterativeServer(void) {}

		long GetTimeout(void) const { return multiplexor.GetTimeout(); }

		void SetTimeout(const long t) { multiplexor.SetTimeout(t); }

		virtual GPL_Boolean Initialize(void);
		virtual void Finalize(void);
		virtual void Wait(void);

	protected:
		virtual	void Reject(const GPL_Opaque key);

	private:
		// No passing around of servers.
		DNA_IterativeServer(const DNA_IterativeServer & server);
		DNA_IterativeServer & operator=(const DNA_IterativeServer & server);

		DNA_IPMultiplexor multiplexor;
		GPL_List<DNA_IPMultiplexable> ready;

};

#endif /* DNA_ISERVER_H */
