
/******************************************************************************

COPYRIGHT_HEADER

******************************************************************************/

#include <dna/dna.h>

DNA_ThreadedServer::DNA_ThreadedServer()
{
}

GPL_Boolean DNA_ThreadedServer::Initialize(void)
{
	if(!DNA_Server::Initialize()) { return FALSE; }
	return TRUE;
}

void DNA_ThreadedServer::Finalize(void)
{
	DNA_Server::Finalize();
}

void DNA_ThreadedServer::Wait(void)
{
	DNA_Connection dummy;
	if(connection.Accept(dummy))
	{
		connections[DNA_GET_HANDLE(dummy)] = dummy;
		AcceptGoodConnection(DNA_GET_HANDLE(dummy));
		DNA_ProcessMessageTask *task;
		task = GetFreeTask();
		task->Begin(this, DNA_GET_HANDLE(dummy));
	}
}

void DNA_ThreadedServer::TendConnection(GPL_Opaque opaque)
{
	SOCKET_HANDLE handle;
	handle = opaque;
	while(1)
	{
		DNA_Message message;
		if(!message.Receive(&(connections[handle]),DNA_BLOCK_INDEFINITELY))
		{
			// If this is an irrecoverable error...
			const DNA_ErrorType type =
				(DNA_ErrorType) connections[handle].GetError().GetType();
			if (DNA_ERROR_NONE != type ||
				DNA_ERROR_INSUFFICIENT_MEMORY != type ||
				DNA_ERROR_NO_DATA_AVAILABLE != type ||
				DNA_ERROR_INTERRUPTED_CALL != type)
			{
				// Allow derived classes to handle the bad connection.
				DropBadConnection((GPL_Opaque) handle);
				return;
			}
		}
		const GPL_String image = message.ToString();
		wbaLog("DNA LOG", "RCV >%s<", image.GetData());

		// Allow derived classes to process the message.
		ProcessMessage(message, (GPL_Opaque) handle);
	}
}

void DNA_ProcessMessageTask::Work(void)
{
	while(1)
	{
fprintf(stderr,"+");
		server->TendConnection((GPL_Opaque) handle);
		Done();
		cond_var.Lock();  //double lock.  first one locks, second one
		server->AddFreeTask(this);
		cond_var.Lock();  //waits for Restart/unlock.emulates condition var
		cond_var.Unlock();
	}
}

